//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "shellapi.h"
#include "ac97gui.h"
#include "ac97.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Trayicon"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

extern bool bIconOnly;

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
    // get current record source
    RecListBox->ItemIndex = Ac97::GetRecordSource();

    // get current record gain
    GainBar->Position = (GainBar->Max - Ac97::GetRecordGain());

    // user want's tray icon mode?
    m_TrayIcon = GetPrivateProfileInt( "AC97", "Icon", 0, "SYSTEM.INI" );

    // icon mode?
    if( m_TrayIcon )
    {
        Apptray->Install( this, "SBLive! Ac97" );
    }

    // hide form after 1 sec?
    if( bIconOnly )
    {
        HideTimer->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RecListBoxClick(TObject *Sender)
{
    // cast to listbox object
    TListBox * tLo = (TListBox *) Sender;

    // get index
    int iIndex = tLo->ItemIndex;

    // change record source
    Ac97::SetRecordSource( iIndex );
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::GainBarChange(TObject *Sender)
{
    // calc new gain
    int nGain = (GainBar->Max - GainBar->Position);

    // upload
    Ac97::SetRecordGain( nGain );

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ResetButtonClick(TObject *Sender)
{
    // reset mixer to defaults
    Ac97::Reset();

    // get current record source
    int x = Ac97::GetRecordSource();
    RecListBox->ItemIndex = x;

    // get current record gain
    GainBar->Position = (GainBar->Max - Ac97::GetRecordGain());
}
//---------------------------------------------------------------------------
 
void __fastcall TMainForm::Email_labelClick(TObject *Sender)
{
    // email
    ShellExecute( this->Parent, "open", "mailto:themusicmaster@hotmail.com",
                  NULL, NULL, SW_NORMAL );

}
//---------------------------------------------------------------------------



void __fastcall TMainForm::ApptrayKeyPress(TObject *Sender, char &Key)
{
    // icon message to show GUI?
    if( Key == TTrayicon::LEFT_DBLCLICK )
    {
        MainForm->Show();
    }

    // icon message to show popup?
    if( Key == TTrayicon::RIGHT_DOWN )
    {
        // get mouse position
        POINT tmpPoint;
        GetCursorPos( &tmpPoint );
        AppPopup->Popup( tmpPoint.x, tmpPoint.y );
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HideTimerTimer(TObject *Sender)
{
    // hide main form and then stop timer
    Hide();
    HideTimer->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Show1Click(TObject *Sender)
{
    // show main form
    MainForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::E1Click(TObject *Sender)
{
    // shut down the app
    Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::WndProc(Messages::TMessage &Message)
{
    // minimize message?
    if( Message.Msg == WM_SYSCOMMAND &&
        Message.WParam == SC_MINIMIZE &&
        m_TrayIcon )
    {
        Message.Msg = WM_CHAR;
        Message.WParam = 0; // make us hide the window
        Message.LParam = 0;
        Dispatch( &Message );
        return;
    }

    // call the original handler
    TForm::WndProc( Message );
}


void __fastcall TMainForm::FormKeyPress(TObject *Sender, char &Key)
{
    // fake minimize event?
    if( Key==NULL )
    {
        Hide();
    }
}
//---------------------------------------------------------------------------

