//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Ac97.h"
#include "dos.h"

USERES("ac97live.res");
USEFORM("ac97gui.cpp", MainForm);
USEUNIT("Ac97.cpp");
//---------------------------------------------------------------------------
bool PreWindow( void );
bool bIconOnly = false;

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    try
    {
         Application->Initialize();
         if( !PreWindow() )
         {
            Application->Title = "AC97 SoundBlaster Live! Tool";
            Application->CreateForm(__classid(TMainForm), &MainForm);
            Application->Run();
         }

    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}

bool PreWindow( void )
{
    int defaultsource, defaultgain, retries;
    bool bResetResult = true;

    // init codec VXD handler
    if( !Ac97::DetectSBLive() )
    {
        // write mesagebox (no window attached)
        MessageBox( NULL, "Could not open EMUAPS.VXD?", "AC97 VXD Handler", MB_OK | MB_ICONEXCLAMATION );
        return true;
    }

    // read in any user config from SYSTEM.INI
    defaultsource = GetPrivateProfileInt( "AC97", "Source", (AC97::SOURCE_LINE+1), "SYSTEM.INI" ) - 1;
    defaultgain = GetPrivateProfileInt( "AC97", "Gain", 0, "SYSTEM.INI" );
    retries = GetPrivateProfileInt( "AC97", "Retries", -1, "SYSTEM.INI" );

    // set defaults
    Ac97::SetDefaults( defaultsource, defaultgain );

    // override default retries?
    if( retries >= 0 )
    {
        Ac97::SetRetries( retries );
    }

    // parameters?
    if( _argv[ 1 ] )
    {
        // don't reset mixer?
        if( strstr( strupr(_argv[ 1 ]), "NO_RESET" ) == NULL )
        {
            bResetResult = Ac97::Reset();
        }

        // go away?
        if( strstr( strupr(_argv[ 1 ]), "NO_GUI" ) )
        {
            return true;
        }

        // go away?
        if( strstr( strupr(_argv[ 1 ]), "ICON_ONLY" ) )
        {
            // icon only mode
            bIconOnly = true;
        }
    }
    else
    {
        // no parameters, reset is mandatory!
        bResetResult = Ac97::Reset();
    }

    // if reset fails, don't do main application
    if( !bResetResult )
    {
        return true;
    }


    return false;
}
//---------------------------------------------------------------------------
